drop table APP.Results;
drop table APP.Student;
drop table APP.Subject;


CREATE table APP.Student (
    ID          INTEGER NOT NULL
                PRIMARY KEY GENERATED ALWAYS AS IDENTITY
                (START WITH 1, INCREMENT BY 1),
    FirstName   VARCHAR(50) NOT NULL,
    LastName    VARCHAR(50) NOT NULL,
    DateOfBirth DATE NOT NULL,
    PersonalNumber INTEGER UNIQUE NOT NULL );

CREATE table APP.Subject (
    ID          INTEGER NOT NULL
                PRIMARY KEY GENERATED ALWAYS AS IDENTITY
                (START WITH 1, INCREMENT BY 1),
    SubjectName VARCHAR(100) NOT NULL,
    Code        VARCHAR(10) UNIQUE NOT NULL,
    Credits     INTEGER NOT NULL,
    HasCredit   CHAR(1),
    HasExam     CHAR(1) );

CREATE table APP.Results (
    ID          INTEGER NOT NULL
                PRIMARY KEY GENERATED ALWAYS AS IDENTITY
                (START WITH 1, INCREMENT BY 1),
    Student_ID  INTEGER NOT NULL,
    Subject_ID  INTEGER NOT NULL,
    Exam        SMALLINT,
    Credit      SMALLINT,
    Grade       INTEGER,
    FOREIGN KEY (Student_ID) REFERENCES APP.Student (ID),
    FOREIGN KEY (Subject_ID) REFERENCES APP.Subject (ID));

insert into APP.Student (FirstName, LastName, DateOfBirth, PersonalNumber) values ('Daniel','Ptacek','20.2.1991', 1111);
insert into APP.Student (FirstName, LastName, DateOfBirth, PersonalNumber) values ('Jan','Novak','13.3.1989', 2222);
insert into APP.Student (FirstName, LastName, DateOfBirth, PersonalNumber) values ('Petr','Novotny','20.8.1990', 3333);

insert into APP.Subject (SubjectName, Code, Credits, HasCredit, HasExam) values ('Matematika','A032MA',7,'N','Y');
insert into APP.Subject (SubjectName, Code, Credits, HasCredit, HasExam) values ('Programovani','A022PR',6,'Y','Y');
insert into APP.Subject (SubjectName, Code, Credits, HasCredit, HasExam) values ('Ekonomika','A054EK',4,'Y','N');

insert into APP.Results (Student_ID, Subject_ID, Exam, Credit, Grade) values (1,1,1,1,2);
insert into APP.Results (Student_ID, Subject_ID, Exam, Credit, Grade) values (1,2,NULL,NULL,NULL);
insert into APP.Results (Student_ID, Subject_ID, Exam, Credit, Grade) values (1,3,1,NULL,NULL);

insert into APP.Results (Student_ID, Subject_ID, Exam, Credit, Grade) values (2,2,1,NULL,NULL);

insert into APP.Results (Student_ID, Subject_ID, Exam, Credit, Grade) values (3,1,NULL,1,3);