/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import business.collections.StudentList;
import business.entities.Student;
import gui.exceptions.DataChangeHandler;
import gui.exceptions.EmptyFieldException;
import gui.exceptions.InvalidDataFormatException;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 *
 * @author balikm1
 */
public class StudentEditor extends JDialog {

    Student item;

    /** Creates new StudentEditor */
    public StudentEditor(Student datasource) {
        this.item = datasource;
        initComponents();
    }

    public StudentEditor() {
        this.item = null;
        initComponents();
    }

    // <editor-fold defaultstate="collapsed" desc="initComponents & events">
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new BorderLayout());

        setTitle(item != null ? "Editace" : "Nový záznam");

        listPanel = new JPanel();
        listPanel.setLayout(new GridLayout(4,2));
        // jmeno
        rowPanel11 = new JPanel();
        rowPanel11.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
        rowPanel12 = new JPanel();
        rowPanel12.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        lblName = new JLabel();
        lblName.setText("Jméno:");
        rowPanel11.add(lblName);
        listPanel.add(rowPanel11);

        txtName = new JTextField();
        txtName.setPreferredSize(new Dimension(100, 20));
        txtName.addKeyListener(new DataChangeHandler());
        if (item != null)
            txtName.setText(item.getFirstName());
        rowPanel12.add(txtName);
        listPanel.add(rowPanel12);

        // prijmeni
        rowPanel21 = new JPanel();
        rowPanel21.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
        rowPanel22 = new JPanel();
        rowPanel22.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        lblSurname = new JLabel();
        lblSurname.setText("Příjmení:");
        rowPanel21.add(lblSurname);
        listPanel.add(rowPanel21);

        txtSurname = new JTextField();
        txtSurname.setPreferredSize(new Dimension(100, 20));
        txtSurname.addKeyListener(new DataChangeHandler());
        if (item != null)
            txtSurname.setText(item.getLastName());
        rowPanel22.add(txtSurname);
        listPanel.add(rowPanel22);

        // datum narozeni
        rowPanel31 = new JPanel();
        rowPanel31.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
        rowPanel32 = new JPanel();
        rowPanel32.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        lblDateOfBirth = new JLabel();
        lblDateOfBirth.setText("Datum narození:");
        rowPanel31.add(lblDateOfBirth);
        listPanel.add(rowPanel31);

        txtDateOfBirth = new JTextField();
        txtDateOfBirth.setPreferredSize(new Dimension(100, 20));
        txtDateOfBirth.addKeyListener(new DataChangeHandler());
        if (item != null && item.getDateOfBirth() != null)
            txtDateOfBirth.setText(new SimpleDateFormat("yyyy-MM-dd").format(item.getDateOfBirth()));
        rowPanel32.add(txtDateOfBirth);
        listPanel.add(rowPanel32);

        // osobni cislo
        rowPanel41 = new JPanel();
        rowPanel41.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));
        rowPanel42 = new JPanel();
        rowPanel42.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        lblPersonalNumber = new JLabel();
        lblPersonalNumber.setText("Osobní číslo:");
        rowPanel41.add(lblPersonalNumber);
        listPanel.add(rowPanel41);

        txtPersonalNumber = new JTextField();
        txtPersonalNumber.setPreferredSize(new Dimension(100, 20));
        txtPersonalNumber.addKeyListener(new DataChangeHandler());
        if (item != null) {
            txtPersonalNumber.setText(Integer.toString(item.getPersonalNumber()));
            txtPersonalNumber.setEditable(false);
        }
        rowPanel42.add(txtPersonalNumber);
        listPanel.add(rowPanel42);

        // buttons
        buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout());

        okButton = new JButton();
        okButton.setText("OK");
        okButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                saveItem();
            }
        });
        buttonPanel.add(okButton);

        cancelButton = new JButton();
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                setVisible(false);
            }
        });
        buttonPanel.add(cancelButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);
        getContentPane().add(listPanel, java.awt.BorderLayout.CENTER);

        this.setResizable(false);
        this.setModal(true);

        pack();
    }

    // </editor-fold>

    public void saveItem() {
        try {
            if (item == null)
                item = createStudent();
            else
                updateStudent(item);
            StudentList.getInstance().saveOrUpdate(item);
            setVisible(false);
        } catch (EmptyFieldException efex) {
            for (JComponent c : efex.getInvalidFields())
                c.setBackground(Color.red);
            JOptionPane.showMessageDialog(this, efex.getMessage());
        } catch (InvalidDataFormatException idfex) {
            for (JComponent c : idfex.getInvalidFields())
                c.setBackground(Color.red);
            JOptionPane.showMessageDialog(this, idfex.getMessage());
        }
    }

    private void validateEmpty() throws EmptyFieldException {
      String eMessage = "";
      List<JComponent> empty = new ArrayList();
      if (txtName.getText().trim().isEmpty()) {
          eMessage += "Name is empty\n";
          empty.add(txtName);
      }
      if (txtSurname.getText().trim().isEmpty()) {
          eMessage += "Surname is empty\n";
          empty.add(txtSurname);
      }
      if (txtDateOfBirth.getText().trim().isEmpty()) {
          eMessage += "Date of birth is empty\n";
          empty.add(txtDateOfBirth);
      }
      if (txtPersonalNumber.getText().trim().isEmpty()) {
          eMessage += "Personal number is empty\n";
          empty.add(txtPersonalNumber);
      }
      if (empty.size() > 0)
          throw new EmptyFieldException(empty, eMessage);
    }

    private Student createStudent() throws EmptyFieldException, InvalidDataFormatException {
      validateEmpty();
      
      String fMessage = "";
      List<JComponent> format = new ArrayList();
      Date dateOfBirth = null;
      try {
          dateOfBirth = new SimpleDateFormat("yyyy-MM-dd").parse(txtDateOfBirth.getText());
      } catch (ParseException pe) {
          fMessage += "Invalid date format\n";
          format.add((txtDateOfBirth));
      }
      int personalNumber = -1;
      try {
          personalNumber = Integer.parseInt(txtPersonalNumber.getText());
      } catch (NumberFormatException pe) {
          fMessage += "Personal number is not a number\n";
          format.add(txtPersonalNumber);
      }
      if (format.size() > 0)
          throw new InvalidDataFormatException(format, fMessage);
      
      return new Student(txtName.getText(), txtSurname.getText(), dateOfBirth, personalNumber);
      
    }

    private Student updateStudent(Student student) throws EmptyFieldException, InvalidDataFormatException {
      validateEmpty();

      String fMessage = "";
      List<JComponent> format = new ArrayList();
      Date dateOfBirth = null;
      try {
          dateOfBirth = new SimpleDateFormat("yyyy-MM-dd").parse(txtDateOfBirth.getText());
      } catch (ParseException pe) {
          fMessage += "Invalid date format\n";
          format.add((txtDateOfBirth));
      }
      if (format.size() > 0)
          throw new InvalidDataFormatException(format, fMessage);

      student.setFirstName(txtName.getText());
      student.setLastName(txtSurname.getText());
      student.setDateOfBirth(dateOfBirth);
      return student;
    }

    // <editor-fold defaultstate="collapsed" desc="Components declaration">

    private JPanel buttonPanel = new JPanel();
    private JPanel listPanel = new JPanel();
    private JButton okButton = new JButton();
    private JButton cancelButton = new JButton();
    private JPanel rowPanel11 = new JPanel();
    private JPanel rowPanel12 = new JPanel();
    private JPanel rowPanel21 = new JPanel();
    private JPanel rowPanel22 = new JPanel();
    private JPanel rowPanel31 = new JPanel();
    private JPanel rowPanel32 = new JPanel();
    private JPanel rowPanel41 = new JPanel();
    private JPanel rowPanel42 = new JPanel();
    private JLabel lblName = new JLabel();
    private JLabel lblSurname = new JLabel();
    private JLabel lblDateOfBirth = new JLabel();
    private JLabel lblPersonalNumber = new JLabel();
    private JTextField txtName = new JTextField();
    private JTextField txtSurname = new JTextField();
    private JTextField txtDateOfBirth = new JTextField();
    private JTextField txtPersonalNumber = new JTextField();

    // </editor-fold>

}
